// Code generated by protoc-gen-go-grpc. DO NOT EDIT.

package cms

import (
	context "context"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// ContentManagementSystemClient is the client API for ContentManagementSystem service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type ContentManagementSystemClient interface {
	GetAuthors(ctx context.Context, in *QueryOpts, opts ...grpc.CallOption) (*Authors, error)
	GetCategories(ctx context.Context, in *QueryOpts, opts ...grpc.CallOption) (*Categories, error)
	GetFeeds(ctx context.Context, in *QueryOpts, opts ...grpc.CallOption) (*Feeds, error)
	GetItems(ctx context.Context, in *QueryOpts, opts ...grpc.CallOption) (*Items, error)
	GetFeedByUUID(ctx context.Context, in *FeedUUIDs, opts ...grpc.CallOption) (*Feed, error)
	GetItemsByFeedUUID(ctx context.Context, in *FeedUUID, opts ...grpc.CallOption) (*Items, error)
}

type contentManagementSystemClient struct {
	cc grpc.ClientConnInterface
}

func NewContentManagementSystemClient(cc grpc.ClientConnInterface) ContentManagementSystemClient {
	return &contentManagementSystemClient{cc}
}

func (c *contentManagementSystemClient) GetAuthors(ctx context.Context, in *QueryOpts, opts ...grpc.CallOption) (*Authors, error) {
	out := new(Authors)
	err := c.cc.Invoke(ctx, "/cms.ContentManagementSystem/GetAuthors", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *contentManagementSystemClient) GetCategories(ctx context.Context, in *QueryOpts, opts ...grpc.CallOption) (*Categories, error) {
	out := new(Categories)
	err := c.cc.Invoke(ctx, "/cms.ContentManagementSystem/GetCategories", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *contentManagementSystemClient) GetFeeds(ctx context.Context, in *QueryOpts, opts ...grpc.CallOption) (*Feeds, error) {
	out := new(Feeds)
	err := c.cc.Invoke(ctx, "/cms.ContentManagementSystem/GetFeeds", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *contentManagementSystemClient) GetItems(ctx context.Context, in *QueryOpts, opts ...grpc.CallOption) (*Items, error) {
	out := new(Items)
	err := c.cc.Invoke(ctx, "/cms.ContentManagementSystem/GetItems", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *contentManagementSystemClient) GetFeedByUUID(ctx context.Context, in *FeedUUIDs, opts ...grpc.CallOption) (*Feed, error) {
	out := new(Feed)
	err := c.cc.Invoke(ctx, "/cms.ContentManagementSystem/GetFeedByUUID", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *contentManagementSystemClient) GetItemsByFeedUUID(ctx context.Context, in *FeedUUID, opts ...grpc.CallOption) (*Items, error) {
	out := new(Items)
	err := c.cc.Invoke(ctx, "/cms.ContentManagementSystem/GetItemsByFeedUUID", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// ContentManagementSystemServer is the server API for ContentManagementSystem service.
// All implementations must embed UnimplementedContentManagementSystemServer
// for forward compatibility
type ContentManagementSystemServer interface {
	GetAuthors(context.Context, *QueryOpts) (*Authors, error)
	GetCategories(context.Context, *QueryOpts) (*Categories, error)
	GetFeeds(context.Context, *QueryOpts) (*Feeds, error)
	GetItems(context.Context, *QueryOpts) (*Items, error)
	GetFeedByUUID(context.Context, *FeedUUIDs) (*Feed, error)
	GetItemsByFeedUUID(context.Context, *FeedUUID) (*Items, error)
	mustEmbedUnimplementedContentManagementSystemServer()
}

// UnimplementedContentManagementSystemServer must be embedded to have forward compatible implementations.
type UnimplementedContentManagementSystemServer struct {
}

func (UnimplementedContentManagementSystemServer) GetAuthors(context.Context, *QueryOpts) (*Authors, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetAuthors not implemented")
}
func (UnimplementedContentManagementSystemServer) GetCategories(context.Context, *QueryOpts) (*Categories, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetCategories not implemented")
}
func (UnimplementedContentManagementSystemServer) GetFeeds(context.Context, *QueryOpts) (*Feeds, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetFeeds not implemented")
}
func (UnimplementedContentManagementSystemServer) GetItems(context.Context, *QueryOpts) (*Items, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetItems not implemented")
}
func (UnimplementedContentManagementSystemServer) GetFeedByUUID(context.Context, *FeedUUIDs) (*Feed, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetFeedByUUID not implemented")
}
func (UnimplementedContentManagementSystemServer) GetItemsByFeedUUID(context.Context, *FeedUUID) (*Items, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetItemsByFeedUUID not implemented")
}
func (UnimplementedContentManagementSystemServer) mustEmbedUnimplementedContentManagementSystemServer() {
}

// UnsafeContentManagementSystemServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to ContentManagementSystemServer will
// result in compilation errors.
type UnsafeContentManagementSystemServer interface {
	mustEmbedUnimplementedContentManagementSystemServer()
}

func RegisterContentManagementSystemServer(s grpc.ServiceRegistrar, srv ContentManagementSystemServer) {
	s.RegisterService(&ContentManagementSystem_ServiceDesc, srv)
}

func _ContentManagementSystem_GetAuthors_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(QueryOpts)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ContentManagementSystemServer).GetAuthors(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/cms.ContentManagementSystem/GetAuthors",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ContentManagementSystemServer).GetAuthors(ctx, req.(*QueryOpts))
	}
	return interceptor(ctx, in, info, handler)
}

func _ContentManagementSystem_GetCategories_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(QueryOpts)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ContentManagementSystemServer).GetCategories(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/cms.ContentManagementSystem/GetCategories",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ContentManagementSystemServer).GetCategories(ctx, req.(*QueryOpts))
	}
	return interceptor(ctx, in, info, handler)
}

func _ContentManagementSystem_GetFeeds_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(QueryOpts)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ContentManagementSystemServer).GetFeeds(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/cms.ContentManagementSystem/GetFeeds",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ContentManagementSystemServer).GetFeeds(ctx, req.(*QueryOpts))
	}
	return interceptor(ctx, in, info, handler)
}

func _ContentManagementSystem_GetItems_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(QueryOpts)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ContentManagementSystemServer).GetItems(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/cms.ContentManagementSystem/GetItems",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ContentManagementSystemServer).GetItems(ctx, req.(*QueryOpts))
	}
	return interceptor(ctx, in, info, handler)
}

func _ContentManagementSystem_GetFeedByUUID_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(FeedUUIDs)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ContentManagementSystemServer).GetFeedByUUID(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/cms.ContentManagementSystem/GetFeedByUUID",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ContentManagementSystemServer).GetFeedByUUID(ctx, req.(*FeedUUIDs))
	}
	return interceptor(ctx, in, info, handler)
}

func _ContentManagementSystem_GetItemsByFeedUUID_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(FeedUUID)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ContentManagementSystemServer).GetItemsByFeedUUID(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/cms.ContentManagementSystem/GetItemsByFeedUUID",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ContentManagementSystemServer).GetItemsByFeedUUID(ctx, req.(*FeedUUID))
	}
	return interceptor(ctx, in, info, handler)
}

// ContentManagementSystem_ServiceDesc is the grpc.ServiceDesc for ContentManagementSystem service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var ContentManagementSystem_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "cms.ContentManagementSystem",
	HandlerType: (*ContentManagementSystemServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "GetAuthors",
			Handler:    _ContentManagementSystem_GetAuthors_Handler,
		},
		{
			MethodName: "GetCategories",
			Handler:    _ContentManagementSystem_GetCategories_Handler,
		},
		{
			MethodName: "GetFeeds",
			Handler:    _ContentManagementSystem_GetFeeds_Handler,
		},
		{
			MethodName: "GetItems",
			Handler:    _ContentManagementSystem_GetItems_Handler,
		},
		{
			MethodName: "GetFeedByUUID",
			Handler:    _ContentManagementSystem_GetFeedByUUID_Handler,
		},
		{
			MethodName: "GetItemsByFeedUUID",
			Handler:    _ContentManagementSystem_GetItemsByFeedUUID_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "cms.proto",
}
